# KnowGo API Client for Dart

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.3
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://www.adaptant.io](https://www.adaptant.io)

## Requirements

Dart 1.20.0 or later OR Flutter 0.0.20 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: knowgo
version: 1.0.0
description: KnowGo API client
dependencies:
  openapi:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  knowgo:
    path: /path/to/knowgo-client-dart
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:knowgo/api.dart';

// TODO Configure API key authorization: app_id
//defaultApiClient.getAuthentication<ApiKeyAuth>('app_id').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('app_id').apiKeyPrefix = 'Bearer';
// TODO Configure HTTP basic authorization: bearerAuth
//defaultApiClient.getAuthentication<HttpBasicAuth>('bearerAuth').username = 'YOUR_USERNAME'
//defaultApiClient.getAuthentication<HttpBasicAuth>('bearerAuth').password = 'YOUR_PASSWORD';
// TODO Configure API key authorization: cookieAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('cookieAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('cookieAuth').apiKeyPrefix = 'Bearer';

var api_instance = EventsApi();
var event = Event(); // Event | Event object to operate on

try {
    var result = api_instance.addEvent(event);
    print(result);
} catch (e) {
    print("Exception when calling EventsApi->addEvent: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api.adaptant.io/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*EventsApi* | [**addEvent**](docs//EventsApi.md#addevent) | **POST** /events | Add a new Event
*EventsApi* | [**deleteEvent**](docs//EventsApi.md#deleteevent) | **DELETE** /events/{eventId} | Delete Event by ID
*EventsApi* | [**getEventById**](docs//EventsApi.md#geteventbyid) | **GET** /events/{eventId} | Find Event by ID
*EventsApi* | [**updateEventWithForm**](docs//EventsApi.md#updateeventwithform) | **POST** /events/{eventId} | Updates an Event with form data
*JourneysApi* | [**addClassificationToJourney**](docs//JourneysApi.md#addclassificationtojourney) | **POST** /journeys/{journeyId}/classifications/{classificationId} | Add a new Journey classification for a specific Journey
*JourneysApi* | [**addJourney**](docs//JourneysApi.md#addjourney) | **POST** /journeys | Add a new Journey
*JourneysApi* | [**createJourneyClassification**](docs//JourneysApi.md#createjourneyclassification) | **POST** /journeys/classifications | Create a Journey classification
*JourneysApi* | [**deleteJourney**](docs//JourneysApi.md#deletejourney) | **DELETE** /journeys/{journeyId} | Delete Journey by ID
*JourneysApi* | [**deleteJourneyClassification**](docs//JourneysApi.md#deletejourneyclassification) | **DELETE** /journeys/classifications/{classificationId} | Delete specified Journey classification
*JourneysApi* | [**getJourneyById**](docs//JourneysApi.md#getjourneybyid) | **GET** /journeys/{journeyId} | Find journey by ID
*JourneysApi* | [**getJourneyClassificationById**](docs//JourneysApi.md#getjourneyclassificationbyid) | **GET** /journeys/classifications/{classificationId} | Get Journey classification by classification id
*JourneysApi* | [**listJourneyClassifications**](docs//JourneysApi.md#listjourneyclassifications) | **GET** /journeys/classifications | Return a list of Journey classifications available for a specific user
*JourneysApi* | [**listJourneyClassificationsByJourneyId**](docs//JourneysApi.md#listjourneyclassificationsbyjourneyid) | **GET** /journeys/{journeyId}/classifications | Return a list of Journey classifications for a specific Journey
*JourneysApi* | [**listJourneys**](docs//JourneysApi.md#listjourneys) | **GET** /journeys | Return a list of journeys available for a specific user
*JourneysApi* | [**listJourneysByUserId**](docs//JourneysApi.md#listjourneysbyuserid) | **GET** /users/{userId}/journeys | Return a list of journeys available for a specific user
*JourneysApi* | [**removeClassificationFromJourney**](docs//JourneysApi.md#removeclassificationfromjourney) | **DELETE** /journeys/{journeyId}/classifications/{classificationId} | Remove a specific classification from a Journey
*JourneysApi* | [**updateJourneyClassificationById**](docs//JourneysApi.md#updatejourneyclassificationbyid) | **PUT** /journeys/classifications/{classificationId} | Update a specified Journey classification
*JourneysApi* | [**updateJourneyWithForm**](docs//JourneysApi.md#updatejourneywithform) | **POST** /journeys/{journeyId} | Updates a Journey with form data
*ServerApi* | [**currentConfig**](docs//ServerApi.md#currentconfig) | **GET** /config | Obtain configuration information about the current KnowGo instance
*ServicesApi* | [**addService**](docs//ServicesApi.md#addservice) | **POST** /services | Register a new KnowGo platform service
*ServicesApi* | [**deleteServiceEndpoint**](docs//ServicesApi.md#deleteserviceendpoint) | **DELETE** /services/{serviceName}/{endpoint} | DELETE pass-through for service-specific endpoint
*ServicesApi* | [**disableServiceByUserId**](docs//ServicesApi.md#disableservicebyuserid) | **DELETE** /users/{userId}/services/{serviceName} | Disable a service for a specific user
*ServicesApi* | [**enableServiceByUserId**](docs//ServicesApi.md#enableservicebyuserid) | **POST** /users/{userId}/services/{serviceName} | Enable a service for a specific user
*ServicesApi* | [**getServiceDefinition**](docs//ServicesApi.md#getservicedefinition) | **GET** /services/{serviceName} | Lookup the service definition for a specific service
*ServicesApi* | [**getServiceEndpoint**](docs//ServicesApi.md#getserviceendpoint) | **GET** /services/{serviceName}/{endpoint} | GET pass-through for service-specific endpoint
*ServicesApi* | [**listServices**](docs//ServicesApi.md#listservices) | **GET** /services | Return a list of available KnowGo platform services
*ServicesApi* | [**listServicesByUserId**](docs//ServicesApi.md#listservicesbyuserid) | **GET** /users/{userId}/services | Return a list of services for a specific user
*ServicesApi* | [**postServiceEndpoint**](docs//ServicesApi.md#postserviceendpoint) | **POST** /services/{serviceName}/{endpoint} | POST pass-through for service-specific endpoint
*ServicesApi* | [**removeServiceDefinition**](docs//ServicesApi.md#removeservicedefinition) | **DELETE** /services/{serviceName} | Deregister a KnowGo platform service
*ServicesApi* | [**updateServiceDefinition**](docs//ServicesApi.md#updateservicedefinition) | **PUT** /services/{serviceName} | Update the service definition for a specific service
*ServicesApi* | [**updateServiceEndpoint**](docs//ServicesApi.md#updateserviceendpoint) | **PUT** /services/{serviceName}/{endpoint} | PUT pass-through for service-specific endpoint
*UsersApi* | [**confirmUserPasswordChangeByRecovery**](docs//UsersApi.md#confirmuserpasswordchangebyrecovery) | **POST** /users/password/confirm | Confirm the change in user password via the recovery mechanism
*UsersApi* | [**createUser**](docs//UsersApi.md#createuser) | **POST** /users | Create user
*UsersApi* | [**deleteUser**](docs//UsersApi.md#deleteuser) | **DELETE** /users/{userId} | Delete user
*UsersApi* | [**disableServiceByUserId**](docs//UsersApi.md#disableservicebyuserid) | **DELETE** /users/{userId}/services/{serviceName} | Disable a service for a specific user
*UsersApi* | [**enableServiceByUserId**](docs//UsersApi.md#enableservicebyuserid) | **POST** /users/{userId}/services/{serviceName} | Enable a service for a specific user
*UsersApi* | [**exportUser**](docs//UsersApi.md#exportuser) | **GET** /users/{userId}/export | Exports all data about current user in CSV format
*UsersApi* | [**getUserById**](docs//UsersApi.md#getuserbyid) | **GET** /users/{userId} | Get user by user id
*UsersApi* | [**listJourneysByUserId**](docs//UsersApi.md#listjourneysbyuserid) | **GET** /users/{userId}/journeys | Return a list of journeys available for a specific user
*UsersApi* | [**listServicesByUserId**](docs//UsersApi.md#listservicesbyuserid) | **GET** /users/{userId}/services | Return a list of services for a specific user
*UsersApi* | [**listVehiclesByUserId**](docs//UsersApi.md#listvehiclesbyuserid) | **GET** /users/{userId}/vehicles | Return a list of vehicles available for a specific user
*UsersApi* | [**loginUser**](docs//UsersApi.md#loginuser) | **POST** /users/login | Logs user into the system and returns an authentication token.
*UsersApi* | [**logoutUser**](docs//UsersApi.md#logoutuser) | **GET** /users/logout | Logs out current logged in user session
*UsersApi* | [**recoverUserPassword**](docs//UsersApi.md#recoveruserpassword) | **POST** /users/password/recover | Initiaties a password recovery operation for the designated user.
*UsersApi* | [**refreshToken**](docs//UsersApi.md#refreshtoken) | **GET** /users/refresh | Refreshes the session token for a logged-in user
*UsersApi* | [**updateUser**](docs//UsersApi.md#updateuser) | **PUT** /users/{userId} | Updated user
*VehiclesApi* | [**addAuto**](docs//VehiclesApi.md#addauto) | **POST** /autos | Add a new auto
*VehiclesApi* | [**deleteAuto**](docs//VehiclesApi.md#deleteauto) | **DELETE** /autos/{autoId} | Deletes an Auto
*VehiclesApi* | [**getAutoById**](docs//VehiclesApi.md#getautobyid) | **GET** /autos/{autoId} | Find auto by ID
*VehiclesApi* | [**listVehicles**](docs//VehiclesApi.md#listvehicles) | **GET** /vehicles | Return a list of vehicles available for a specific user
*VehiclesApi* | [**listVehiclesByUserId**](docs//VehiclesApi.md#listvehiclesbyuserid) | **GET** /users/{userId}/vehicles | Return a list of vehicles available for a specific user
*VehiclesApi* | [**updateAuto**](docs//VehiclesApi.md#updateauto) | **PUT** /autos | Update an existing auto
*VehiclesApi* | [**updateAutoWithForm**](docs//VehiclesApi.md#updateautowithform) | **POST** /autos/{autoId} | Updates an auto with form data


## Documentation For Models

 - [Auto](docs//Auto.md)
 - [AuthCredentials](docs//AuthCredentials.md)
 - [Config](docs//Config.md)
 - [Event](docs//Event.md)
 - [Journey](docs//Journey.md)
 - [JourneyClassifications](docs//JourneyClassifications.md)
 - [PasswordRecoveryConfirmation](docs//PasswordRecoveryConfirmation.md)
 - [ServiceDefinition](docs//ServiceDefinition.md)
 - [ServiceDefinitionDataNeeded](docs//ServiceDefinitionDataNeeded.md)
 - [ServiceDefinitionPurposes](docs//ServiceDefinitionPurposes.md)
 - [User](docs//User.md)


## Documentation For Authorization


## app_id

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header

## bearerAuth

- **Type**: HTTP basic authentication

## cookieAuth

- **Type**: API key
- **API key parameter name**: token
- **Location**: 


## Author

labs@adaptant.io


